/*
 * Tencent is pleased to support the open source community by making BK-CI 蓝鲸持续集成平台 available.
 *
 * Copyright (C) 2019 THL A29 Limited, a Tencent company.  All rights reserved.
 *
 * BK-CI 蓝鲸持续集成平台 is licensed under the MIT license.
 *
 * A copy of the MIT License is included in this file.
 *
 * ...
 */

package cd.casic.devops.common.worker.env;


import static cd.casic.devops.common.worker.Constants.BUILD_ID;
import static cd.casic.devops.common.worker.Constants.BUILD_TYPE;

public class BuildEnv {
    private static String buildType;

    public static BuildType getBuildType() {
        if (buildType == null) {
            synchronized (BuildEnv.class) {
                if (buildType == null) {
                    buildType = System.getProperty(BUILD_TYPE);
                }
            }
        }
        if (buildType == null || !BuildType.contains(buildType)) {
            return BuildType.AGENT;
        }
        return BuildType.valueOf(buildType);
    }

    public static void setBuildType(BuildType value) {
        buildType = value.name();
    }

    public static boolean isThirdParty() {
        return getBuildType() == BuildType.AGENT;
    }

    public static String getBuildId() {
        return System.getProperty(BUILD_ID);
    }

    public static void setBuildId(String buildId) {
        System.setProperty(BUILD_ID, buildId);
    }
} 